﻿package sqviewer 
{
	import flash.display.DisplayObjectContainer;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.net.URLLoader;  
    import flash.net.URLRequest;  
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Kei Takahashi
	 */
	public class Entry
	{
		private var container:DisplayObjectContainer;
		private var url:String;
		private var index:int;
		public var loader:Loader;  

		private var aniT:Number;

		private var mode:int;
		public static var MODE_NORMAL:int = 10;
		public static var MODE_FOCUSING:int = 11;
		public static var MODE_FOCUSED:Number = 12;
		public static var MODE_UNFOCUSING:Number = 13;
		public static var MODE_MAXIMIZED:Number = 14;
		public static var MODE_MAXIMIZING:Number = 15;
		public static var MODE_UNMAXIMIZING:Number = 16;

		public static var MODE_MAXIMIZING_FADEIN:Number = 17;
		public static var MODE_UNMAXIMIZING_FADEOUT:Number = 18;

		public var oldNormW:int = -1;
		
		private var normX:int = 1;
		private var normY:int = 1;
		
		private var zoomX:int = 1;
		private var zoomY:int = 1;
		
		private var origX:int = 1;
		private var origY:int = 1;
		private var origW:int = 1;
		private var origH:int = 1;
		private var origAlpha:int = 1;

		private var destW:int = 1;
		private var destH:int = 1;
		private var destX:int = 1;
		private var destY:int = 1;
		private var destAlpha:int;

		private var width:int = 1;
		private var height:int = 1;
		private var x:int = 1;
		private var y:int = 1;
		private var alpha:Number;

		public var s:Sprite;
		
		public function Entry(container:DisplayObjectContainer, url:String, index:int) 
		{
			s = new Sprite();
			container.addChild(s);
			this.container = container;
			this.url = url;
			this.index = index;
			beginLoad();
			this.mode = MODE_NORMAL;
		}
		
		private function beginLoad():void
        {  
            loader = new Loader();  
            loader.load(new URLRequest(url));  
            loader.contentLoaderInfo.addEventListener(Event.COMPLETE, afterLoad);  
        }
		
		private function afterLoad(event:Event):void
		{
			aniT = 1.0;
			s.addChild(loader);
		}
		
		public function myHitTest(mouseX:Number, mouseY:Number):Boolean {
			if (mouseX < x) return false;
			if (x + width < mouseX) return false;
			if (mouseY < y) return false;
			if (y + height < mouseY) return false;
			return true;
		}
		

		private function updateSize():void {
			s.graphics.clear();
			switch(mode) {
				case MODE_NORMAL:
				case MODE_FOCUSED:
				case MODE_FOCUSING:
				case MODE_UNFOCUSING:
					drawFrame();
					break;
			}
			var t:Number = 1 - (1 - aniT) * (1 - aniT) * (1 - aniT);
			if (t > 1.0) t = 1.0;
			x = origX * (1 - t) + destX * t;
            y = origY * (1 - t) + destY * t;
			width = origW * (1 - t) + destW * t;
            height = origH * (1 - t) + destH * t;
			alpha = origAlpha * (1 - t) + destAlpha * t;
			
			loader.x = x;// * 0.02;
			loader.y = y;// * 0.02;
			loader.width = width;// * 0.96;
			loader.height = height;// * 0.96;
			loader.alpha = alpha;
		}

		
		public function onFrame(event:Event):void {
			updateSize();
			
			switch(mode) {
				case MODE_FOCUSED:
				case MODE_NORMAL:
				case MODE_MAXIMIZED:
				return;
			}
			
			aniT += 0.1;
			if (aniT < 1.0) return;

			switch(mode) {
				case MODE_MAXIMIZING: {
					mode = MODE_MAXIMIZED;
					break;
				}
				case MODE_UNMAXIMIZING: {
					mode = MODE_FOCUSED;
					break;
				}
				case MODE_FOCUSING: {
					mode = MODE_FOCUSED;
					break;
				}
				case MODE_UNFOCUSING: {
					mode = MODE_NORMAL;
					break;
				}
				case MODE_MAXIMIZING_FADEIN: {
					mode = MODE_MAXIMIZED;
					break;
				}
				case MODE_UNMAXIMIZING_FADEOUT: {
					mode = MODE_NORMAL;
					origW = destW = Env.normW;
					origH = destH = Env.normH;
					origX = destX = normX;
					origY = destY = normY;
					break;
				}
			}

		}
		
		private function drawFrame():void {
			s.graphics.lineStyle(1,0x6666aa, 0.6);
			s.graphics.beginFill(0xcccccc, 0.3);
			s.graphics.drawRect(x - width * Env.frameRatio,
								y - height * Env.frameRatio,
								width * (1 + Env.frameRatio * 2),
								height * (1 + Env.frameRatio * 2));
		}
		

		private function saveOrig():void {
			origX = x;
			origY = y;
			origW = width;
			origH = height;
			origAlpha = alpha;
		}
		
		public function focusOn():void {
			mode = MODE_FOCUSING;
			origX = x;
			origY = y;
			origW = width;
			origH = height;
			
			destX = zoomX;
			destY = zoomY;
			destW = Env.zoomW;
			destH = Env.zoomH;
			aniT = 0.0;
			updateSize();
		}

		public function focusOut():void {
			mode = MODE_UNFOCUSING;
			saveOrig();
			
			destX = normX;
			destY = normY;
			destW = Env.normW;
			destH = Env.normH;
			destAlpha = 1.0;			
			aniT = 0.0;
			updateSize();
		}

		public function maximize():void {
			mode = MODE_MAXIMIZING;
			saveOrig();
			
			destX = 0;
			destY = 0;
			destW = Env.W;
			destH = Env.H;
			destAlpha = 1.0;
			aniT = 0.0;
			updateSize();
		}

		public function unmaximize():void {
			mode = MODE_UNMAXIMIZING;
			saveOrig();
			
			destX = zoomX;
			destY = zoomY;
			destW = Env.zoomW;
			destH = Env.zoomH;
			destAlpha = 1.0;
			aniT = 0.0;
			updateSize();
		}
		
		public function unmaximizeFadeOut():void {
			mode = MODE_UNMAXIMIZING_FADEOUT;
			saveOrig();
			
			destX = 0;
			destY = 0;
			destW = Env.W;
			destH = Env.H;
			destAlpha = 1.0;
			aniT = 0.0;
			updateSize();
		}

		public function maximizeFadeIn():void {
			mode = MODE_MAXIMIZING_FADEIN;
			origX = 0;
			origY = 0;
			origW = Env.W;
			origH = Env.H;
			origAlpha = 0.0;
			
			destX = 0;
			destY = 0;
			destW = Env.W;
			destH = Env.H;
			destAlpha = 1.0;
			aniT = 0.0;
			updateSize();
		}
		
		
		public function setLapIndex(lapIndex:int):void {
			container.setChildIndex(this.s, lapIndex);
		}
		
		public function resize():void {
			normX = (index % Env.N) * (Env.normW + Env.marginW) + Env.marginW;
            normY = int(index / Env.N) * (Env.normH + Env.marginH) + Env.marginH;

			zoomX = normX - (Env.zoomW - Env.normW )/ 2;
			zoomY = normY - (Env.zoomH - Env.normH ) / 2;
			
			if (zoomX < Env.marginW * 3) {
				zoomX = Env.marginW * 3;
			} else if (zoomX + Env.zoomW > Env.W - Env.marginW * 3) {
				zoomX = Env.W - Env.marginW * 3 - Env.zoomW;
			}
			
			if (zoomY < Env.marginH * 3) {
				zoomY = Env.marginH * 3;
			} else if (zoomY + Env.zoomH > Env.H - Env.marginH * 3) {
				zoomY = Env.H - Env.marginH * 3 - Env.zoomH;
			}
			if(oldNormW <= 0){
				origX = destX = normX;
				origY = destY = normY;
				origW = destW = Env.normW;
				origH = destH = Env.normH;
				origAlpha = destAlpha = 1.0;
			} else {
				var r:Number = Env.normW / oldNormW;
				origX *= r;
				origY *= r;
				origW *= r;
				origH *= r;
				destX *= r;
				destY *= r;
				destW *= r;
				destH *= r;
				x *= r;
				y *= r;
			}
			oldNormW = Env.normW;
			updateSize();
		}
	}
}
